﻿using Syncfusion.UI.Xaml.Schedule;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Core;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace SingleAppointment_SfSchedule_WinRT
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {

        private bool _isNewAppointment;

        public bool IsNewAppointment
        {
            get { return _isNewAppointment; }
            set { _isNewAppointment = value; }
        }

        private ScheduleAppointment _lastAppointment;

        public ScheduleAppointment LastAppointment
        {
            get { return _lastAppointment; }
            set { _lastAppointment = value; }
        }
        

        public MainPage()
        {
            LastAppointment = new ScheduleAppointment();

            this.InitializeComponent();

            Random _randomNumber = new Random();
            DateTime _dateTime = DateTime.Now.SubractDays(15);

            for (int i = 0; i < 10; i++)
            {
                DateTime _startDate = _dateTime.AddDays(i);
                this.schedule1.Appointments.Add(new ScheduleAppointment() { StartTime = _startDate, EndTime = _startDate.AddHours(2), Subject = "Appointment No - : " +i.ToString()});
            }

            this.schedule1.Appointments.CollectionChanged += Appointments_CollectionChanged;

            this.schedule1.AppointmentEditorClosed += schedule1_AppointmentEditorClosed;
        }

        async void schedule1_AppointmentEditorClosed(object sender, AppointmentEditorClosedEventArgs e)
        {
            MessageDialog _appointmentStatus = new MessageDialog("");
            UICommand _yesButton = new UICommand("Yes");
            _yesButton.Invoked = YesBtnClick;
            _appointmentStatus.Commands.Add(_yesButton);

            UICommand _noButton = new UICommand("No");
            _noButton.Invoked = NoBtnClick;
            _appointmentStatus.Commands.Add(_noButton);

            int _count = this.schedule1.Appointments.Count;

            if (IsNewAppointment)
            {
                DateTime _newAppointmentDate = LastAppointment.StartTime.Date;
                _appointmentStatus.Title = "Waning!!";
                _appointmentStatus.Content = "Appointment already exist here, Do you want to keep it?";
                await _appointmentStatus.ShowAsync();
            }
        }

        void Appointments_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            
            if (e.Action == System.Collections.Specialized.NotifyCollectionChangedAction.Add )
            {
                foreach (ScheduleAppointment item in this.schedule1.Appointments)
                {
                    LastAppointment = (e.NewItems[0] as ScheduleAppointment);
                    if (LastAppointment.StartTime.Date == item.StartTime.Date && item.RecurrenceID != LastAppointment.RecurrenceID)
                    {
                        IsNewAppointment = true;
                    }
                }
            }
            else
            {
                IsNewAppointment = false;
            }
        }

        private void NoBtnClick(IUICommand command)
        {
            //To delete recently added appointment
           this.schedule1.Appointments.Remove(LastAppointment);
        }

        private void YesBtnClick(IUICommand command)
        {
            //Continue
        }

    }
}
